<?php

require_once ROOTPATH.'/app/plugins/icalcreator/iCalUtilityFunctions.class.php';
require_once ROOTPATH.'/app/plugins/icalcreator/iCalcreator.class.php';        
require_once ROOTPATH.'/modules/calendar/constants.php';

//TODO:Timeout request
set_time_limit( 600 );
class iCal implements Formatter 
{
    static $timezonesMap = array ('(GMT-12.00) International Date Line West' => 'Etc/GMT+12', '(GMT-11.00) Midway Island / Samoa' => 'Pacific/Midway', '(GMT-10.00) Hawaii' => 'Pacific/Honolulu', '(GMT-09.00) Alaska' => 'America/Anchorage', '(GMT-08.00) Pacific Time (US & Canada) / Tijuana' => 'America/Los_Angeles', '(GMT-08.00) Tijuana / Baja California' => 'America/Tijuana', '(GMT-07.00) Arizona' => 'America/Phoenix', '(GMT-07.00) Chihuahua / La Paz / Mazatlan - Old' => 'America/Chihuahua', '(GMT-07.00) Mountain Time (US & Canada)' => 'America/Denver', '(GMT-06.00) Central America' => 'America/Guatemala', '(GMT-06.00) Central Time (US & Canada)' => 'America/Chicago', '(GMT-06.00) Guadalajara / Mexico City / Monterrey - Old' => 'America/Mexico_City', '(GMT-06.00) Saskatchewan' => 'America/Regina', '(GMT-05.00) Bogota / Lima / Quito' => 'America/Bogota', '(GMT-05.00) Eastern Time (US & Canada)' => 'America/New_York', '(GMT-05.00) Indiana (East)' => 'America/Indiana/Indianapolis', '(GMT-04.30) Caracas' => 'America/Caracas', '(GMT-04.00) Atlantic Time (Canada)' => 'America/Halifax', '(GMT-04.00) Georgetown' => 'America/Guyana', '(GMT-04.00) Caracas / La Paz' => 'America/La_Paz', '(GMT-04.00) Manaus' => 'America/Manaus', '(GMT-04.00) Santiago' => 'America/Santiago', '(GMT-03.30) Newfoundland' => 'America/St_Johns', '(GMT-03.00) Brasilia' => 'America/Sao_Paulo', '(GMT-03.00) Buenos Aires / Georgetown' => 'America/Argentina/Buenos_Aires', '(GMT-03.00) Greenland' => 'America/Godthab', '(GMT-03.00) Montevideo' => 'America/Montevideo', '(GMT-02.00) Mid-Atlantic' => 'Atlantic/South_Georgia', '(GMT-01.00) Azores' => 'Atlantic/Azores', '(GMT-01.00) Cape Verde Is.' => 'Atlantic/Cape_Verde', '(GMT) Casablanca' => 'Africa/Casablanca', '(GMT) Greenwich Mean Time - Dublin / Edinburgh / Lisbon / London' => 'Europe/London', '(GMT) Casablanca / Monrovia' => 'Africa/Monrovia', '(GMT+01.00) Amsterdam / Berlin / Bern / Rome / Stockholm / Vienna' => 'Europe/Berlin', '(GMT+01.00) Belgrade / Bratislava / Budapest / Ljubljana / Prague' => 'Europe/Belgrade', '(GMT+01.00) Brussels / Copenhagen / Madrid / Paris' => 'Europe/Brussels', '(GMT+01.00) Sarajevo / Skopje / Warsaw / Zagreb' => 'Europe/Warsaw', '(GMT+01.00) West Central Africa' => 'Africa/Algiers', '(GMT+02.00) Windhoek' => 'Africa/Windhoek', '(GMT+02.00) Amman' => 'Asia/Amman', '(GMT+02.00) Bucharest' => 'Europe/Athens', '(GMT+02.00) Beirut' => 'Asia/Beirut', '(GMT+02.00) Cairo' => 'Africa/Cairo', '(GMT+02.00) Harare / Pretoria' => 'Africa/Harare', '(GMT+02.00) Helsinki / Kyiv / Riga / Sofia / Tallinn / Vilnius' => 'Europe/Helsinki', '(GMT+02.00) Jerusalem' => 'Asia/Jerusalem', '(GMT+02.00) Minsk' => 'Europe/Minsk', '(GMT+03.00) Baghdad' => 'Asia/Baghdad', '(GMT+03.00) Kuwait / Riyadh' => 'Asia/Kuwait', '(GMT+03.00) Moscow / St. Petersburg / Volgograd' => 'Europe/Moscow', '(GMT+03.00) Nairobi' => 'Africa/Nairobi', '(GMT+04.00) Caucasus Standard Time' => 'Asia/Tbilisi', '(GMT+03.30) Tehran' => 'Asia/Tehran', '(GMT+04.00) Abu Dhabi / Muscat' => 'Asia/Muscat', '(GMT+04.00) Baku / Tbilisi / Yerevan' => 'Asia/Baku', '(GMT+04.00) Yerevan' => 'Asia/Yerevan', '(GMT+04.30) Kabul' => 'Asia/Kabul', '(GMT+05.00) Ekaterinburg' => 'Asia/Yekaterinburg', '(GMT+05.00) Islamabad / Karachi / Tashkent' => 'Asia/Karachi', '(GMT+05.00) Tashkent' => 'Asia/Tashkent', '(GMT+05.30) Chennai / Kolkata / Mumbai / New Delhi' => 'Asia/Kolkata', '(GMT+06.00) Sri Jayawardenepura' => 'Asia/Colombo', '(GMT+05.45) Kathmandu' => 'Asia/Katmandu', '(GMT+06.00) Almaty / Novosibirsk' => 'Asia/Novosibirsk', '(GMT+06.00) Astana / Dhaka' => 'Asia/Dhaka', '(GMT+06.30) Rangoon' => 'Asia/Rangoon', '(GMT+07.00) Bangkok / Hanoi / Jakarta' => 'Asia/Bangkok', '(GMT+07.00) Krasnoyarsk' => 'Asia/Krasnoyarsk', '(GMT+08.00) Beijing / Chongqing / Hong Kong / Urumqi' => 'Asia/Hong_Kong', '(GMT+08.00) Irkutsk / Ulaan Bataar' => 'Asia/Irkutsk', '(GMT+08.00) Kuala Lumpur / Singapore' => 'Asia/Kuala_Lumpur', '(GMT+08.00) Perth' => 'Australia/Perth', '(GMT+08.00) Taipei' => 'Asia/Taipei', '(GMT+09.00) Osaka / Sapporo / Tokyo' => 'Asia/Tokyo', '(GMT+09.00) Seoul' => 'Asia/Seoul', '(GMT+09.00) Yakutsk' => 'Asia/Yakutsk', '(GMT+09.30) Adelaide' => 'Australia/Adelaide', '(GMT+09.30) Darwin' => 'Australia/Darwin', '(GMT+10.00) Brisbane' => 'Australia/Brisbane', '(GMT+10.00) Canberra / Melbourne / Sydney' => 'Australia/Sydney', '(GMT+10.00) Guam / Port Moresby' => 'Pacific/Guam', '(GMT+10.00) Hobart' => 'Australia/Hobart', '(GMT+10.00) Vladivostok' => 'Asia/Vladivostok', '(GMT+11.00) Magadan / Solomon Is. / New Caledonia' => 'Asia/Magadan', '(GMT+12.00) Auckland / Wellington' => 'Pacific/Auckland', '(GMT+12.00) Fiji / Kamchatka / Marshall Is.' => 'Pacific/Fiji', '(GMT+13.00) Nuku\'alofa' => 'Pacific/Tongatapu' );
//    static $timezonesOutlookID = array('Europe/London' => '1' ,'Europe/Brussels' => '3' ,'Europe/Berlin' => '4' ,'America/New_York' => '5' ,'Europe/Belgrade' => '6' ,'Europe/Minsk' => '7' ,'America/Sao_Paulo' => '8' ,'America/Halifax' => '9' ,'America/New_York' => '10' ,'America/Chicago' => '11' ,'America/Denver' => '12' ,'America/Los_Angeles' => '13' ,'America/Anchorage' => '14' ,'Pacific/Honolulu' => '15' ,'Pacific/Midway' => '16' ,'Pacific/Auckland' => '17' ,'Australia/Brisbane' => '18' ,'Australia/Adelaide' => '19' ,'Asia/Tokyo' => '20' ,'Asia/Hong_Kong' => '21' ,'Asia/Bangkok' => '22' ,'Asia/Kolkata' => '23' ,'Asia/Muscat' => '24' ,'Asia/Tehran' => '25' ,'Asia/Baghdad' => '26' ,'Asia/Jerusalem' => '27' ,'America/St_Johns' => '28' ,'Atlantic/Azores' => '29' ,'Atlantic/South_Georgia' => '30' ,'Africa/Casablanca' => '31' ,'America/La_Paz' => '33' ,'America/Indiana/Indianapolis' => '34' ,'America/Bogota' => '35' ,'America/Regina' => '36' ,'America/Mexico_City' => '37' ,'America/Phoenix' => '38' ,'Etc/GMT+12' => '39' ,'Pacific/Fiji' => '40' ,'Asia/Magadan' => '41' ,'Australia/Hobart' => '42' ,'Pacific/Guam' => '43' ,'Australia/Darwin' => '44' ,'Asia/Hong_Kong' => '45' ,'Asia/Novosibirsk' => '46' ,'Asia/Kabul' => '48' ,'Africa/Cairo' => '49' ,'Africa/Harare' => '50' ,'Europe/Moscow' => '51' ,'Australia/Sydney' => '52' ,'Australia/Sydney' => '53' ,'Australia/Adelaide' => '54' ,'Australia/Hobart' => '55' ,'America/Santiago' => '56' ,'Australia/Pert' => '57' ,'America/Tijuana' => '59' ,'Asia/Tbilisi' => '60' ,'Australia/Sydney' => '61' ,'America/Caracas' => '62' ,'Asia/Amman' => '63' ,'Asia/Baku' => '64' ,'Asia/Yerevan' => '65' ,'Europe/Moscow' => '66' ,'America/Argentina/Buenos_Aires' => '67' ,'America/Montevideo' => '72');  
    static $suportedTimzones = array('Africa/Abidjan' ,'Africa/Accra' ,'Africa/Addis_Ababa' ,'Africa/Algiers' ,'Africa/Asmara' ,'Africa/Asmera' ,'Africa/Bamako' ,'Africa/Bangui' ,'Africa/Banjul' ,'Africa/Bissau' ,'Africa/Blantyre' ,'Africa/Brazzaville' ,'Africa/Bujumbura' ,'Africa/Cairo' ,'Africa/Casablanca' ,'Africa/Ceuta' ,'Africa/Conakry' ,'Africa/Dakar' ,'Africa/Dar_es_Salaam' ,'Africa/Djibouti' ,'Africa/Douala' ,'Africa/El_Aaiun' ,'Africa/Freetown' ,'Africa/Gaborone' ,'Africa/Harare' ,'Africa/Johannesburg' ,'Africa/Kampala' ,'Africa/Khartoum' ,'Africa/Kigali' ,'Africa/Kinshasa' ,'Africa/Lagos' ,'Africa/Libreville' ,'Africa/Lome' ,'Africa/Luanda' ,'Africa/Lubumbashi' ,'Africa/Lusaka' ,'Africa/Malabo' ,'Africa/Maputo' ,'Africa/Maseru' ,'Africa/Mbabane' ,'Africa/Mogadishu' ,'Africa/Monrovia' ,'Africa/Nairobi' ,'Africa/Ndjamena' ,'Africa/Niamey' ,'Africa/Nouakchott' ,'Africa/Ouagadougou' ,'Africa/Porto-Novo' ,'Africa/Sao_Tome' ,'Africa/Timbuktu' ,'Africa/Tripoli' ,'Africa/Tunis' ,'Africa/Windhoek' ,'America/Adak' ,'America/Anchorage' ,'America/Anguilla' ,'America/Antigua' ,'America/Araguaina' ,'America/Argentina/Buenos_Aires' ,'America/Argentina/Catamarca' ,'America/Argentina/ComodRivadavia' ,'America/Argentina/Cordoba' ,'America/Argentina/Jujuy' ,'America/Argentina/La_Rioja' ,'America/Argentina/Mendoza' ,'America/Argentina/Rio_Gallegos' ,'America/Argentina/Salta' ,'America/Argentina/San_Juan' ,'America/Argentina/San_Luis' ,'America/Argentina/Tucuman' ,'America/Argentina/Ushuaia' ,'America/Aruba' ,'America/Asuncion' ,'America/Atikokan' ,'America/Atka' ,'America/Bahia' ,'America/Barbados' ,'America/Belem' ,'America/Belize' ,'America/Blanc-Sablon' ,'America/Boa_Vista' ,'America/Bogota' ,'America/Boise' ,'America/Buenos_Aires' ,'America/Cambridge_Bay' ,'America/Campo_Grande' ,'America/Cancun' ,'America/Caracas' ,'America/Catamarca' ,'America/Cayenne' ,'America/Cayman' ,'America/Chicago' ,'America/Chihuahua' ,'America/Coral_Harbour' ,'America/Cordoba' ,'America/Costa_Rica' ,'America/Cuiaba' ,'America/Curacao' ,'America/Danmarkshavn' ,'America/Dawson_Creek' ,'America/Dawson' ,'America/Denver' ,'America/Detroit' ,'America/Dominica' ,'America/Edmonton' ,'America/Eirunepe' ,'America/El_Salvador' ,'America/Ensenada' ,'America/Fort_Wayne' ,'America/Fortaleza' ,'America/Glace_Bay' ,'America/Godthab' ,'America/Goose_Bay' ,'America/Grand_Turk' ,'America/Grenada' ,'America/Guadeloupe' ,'America/Guatemala' ,'America/Guayaquil' ,'America/Guyana' ,'America/Halifax' ,'America/Havana' ,'America/Hermosillo' ,'America/Indiana/Indianapolis' ,'America/Indiana/Knox' ,'America/Indiana/Marengo' ,'America/Indiana/Petersburg' ,'America/Indiana/Tell_City' ,'America/Indiana/Vevay' ,'America/Indiana/Vincennes' ,'America/Indiana/Winamac' ,'America/Indianapolis' ,'America/Inuvik' ,'America/Iqaluit' ,'America/Jamaica' ,'America/Jujuy' ,'America/Juneau' ,'America/Kentucky/Louisville' ,'America/Kentucky/Monticello' ,'America/Knox_IN' ,'America/La_Paz' ,'America/Lima' ,'America/Los_Angeles' ,'America/Louisville' ,'America/Maceio' ,'America/Managua' ,'America/Manaus' ,'America/Marigot' ,'America/Martinique' ,'America/Matamoros' ,'America/Mazatlan' ,'America/Mendoza' ,'America/Menominee' ,'America/Merida' ,'America/Mexico_City' ,'America/Miquelon' ,'America/Moncton' ,'America/Monterrey' ,'America/Montevideo' ,'America/Montreal' ,'America/Montserrat' ,'America/Nassau' ,'America/New_York' ,'America/Nipigon' ,'America/Nome' ,'America/Noronha' ,'America/North_Dakota/Center' ,'America/North_Dakota/New_Salem' ,'America/Ojinaga' ,'America/Panama' ,'America/Pangnirtung' ,'America/Paramaribo' ,'America/Phoenix' ,'America/Port_of_Spain' ,'America/Port-au-Prince' ,'America/Porto_Acre' ,'America/Porto_Velho' ,'America/Puerto_Rico' ,'America/Rainy_River' ,'America/Rankin_Inlet' ,'America/Recife' ,'America/Regina' ,'America/Resolute' ,'America/Rio_Branco' ,'America/Rosario' ,'America/Santa_Isabel' ,'America/Santarem' ,'America/Santiago' ,'America/Santo_Domingo' ,'America/Sao_Paulo' ,'America/Scoresbysund' ,'America/Shiprock' ,'America/St_Barthelemy' ,'America/St_Johns' ,'America/St_Kitts' ,'America/St_Lucia' ,'America/St_Thomas' ,'America/St_Vincent' ,'America/Swift_Current' ,'America/Tegucigalpa' ,'America/Thule' ,'America/Thunder_Bay' ,'America/Tijuana' ,'America/Toronto' ,'America/Tortola' ,'America/Vancouver' ,'America/Virgin' ,'America/Whitehorse' ,'America/Winnipeg' ,'America/Yakutat' ,'America/Yellowknife' ,'Antarctica/Casey' ,'Antarctica/Davis' ,'Antarctica/DumontDUrville' ,'Antarctica/Macquarie' ,'Antarctica/Mawson' ,'Antarctica/McMurdo' ,'Antarctica/Palmer' ,'Antarctica/Rothera' ,'Antarctica/South_Pole' ,'Antarctica/Syowa' ,'Antarctica/Vostok' ,'Arctic/Longyearbyen' ,'Asia/Aden' ,'Asia/Almaty' ,'Asia/Amman' ,'Asia/Anadyr' ,'Asia/Aqtau' ,'Asia/Aqtobe' ,'Asia/Ashgabat' ,'Asia/Ashkhabad' ,'Asia/Baghdad' ,'Asia/Bahrain' ,'Asia/Baku' ,'Asia/Bangkok' ,'Asia/Beirut' ,'Asia/Bishkek' ,'Asia/Brunei' ,'Asia/Calcutta' ,'Asia/Choibalsan' ,'Asia/Chongqing' ,'Asia/Chungking' ,'Asia/Colombo' ,'Asia/Dacca' ,'Asia/Damascus' ,'Asia/Dhaka' ,'Asia/Dili' ,'Asia/Dubai' ,'Asia/Dushanbe' ,'Asia/Gaza' ,'Asia/Harbin' ,'Asia/Ho_Chi_Minh' ,'Asia/Hong_Kong' ,'Asia/Hovd' ,'Asia/Irkutsk' ,'Asia/Istanbul' ,'Asia/Jakarta' ,'Asia/Jayapura' ,'Asia/Jerusalem' ,'Asia/Kabul' ,'Asia/Kamchatka' ,'Asia/Karachi' ,'Asia/Kashgar' ,'Asia/Kathmandu' ,'Asia/Katmandu' ,'Asia/Kolkata' ,'Asia/Krasnoyarsk' ,'Asia/Kuala_Lumpur' ,'Asia/Kuching' ,'Asia/Kuwait' ,'Asia/Macao' ,'Asia/Macau' ,'Asia/Magadan' ,'Asia/Makassar' ,'Asia/Manila' ,'Asia/Muscat' ,'Asia/Nicosia' ,'Asia/Novokuznetsk' ,'Asia/Novosibirsk' ,'Asia/Omsk' ,'Asia/Oral' ,'Asia/Phnom_Penh' ,'Asia/Pontianak' ,'Asia/Pyongyang' ,'Asia/Qatar' ,'Asia/Qyzylorda' ,'Asia/Rangoon' ,'Asia/Riyadh' ,'Asia/Saigon' ,'Asia/Sakhalin' ,'Asia/Samarkand' ,'Asia/Seoul' ,'Asia/Shanghai' ,'Asia/Singapore' ,'Asia/Taipei' ,'Asia/Tashkent' ,'Asia/Tbilisi' ,'Asia/Tehran' ,'Asia/Tel_Aviv' ,'Asia/Thimbu' ,'Asia/Thimphu' ,'Asia/Tokyo' ,'Asia/Ujung_Pandang' ,'Asia/Ulaanbaatar' ,'Asia/Ulan_Bator' ,'Asia/Urumqi' ,'Asia/Vientiane' ,'Asia/Vladivostok' ,'Asia/Yakutsk' ,'Asia/Yekaterinburg' ,'Asia/Yerevan' ,'Atlantic/Azores' ,'Atlantic/Bermuda' ,'Atlantic/Canary' ,'Atlantic/Cape_Verde' ,'Atlantic/Faeroe' ,'Atlantic/Faroe' ,'Atlantic/Jan_Mayen' ,'Atlantic/Madeira' ,'Atlantic/Reykjavik' ,'Atlantic/South_Georgia' ,'Atlantic/St_Helena' ,'Atlantic/Stanley' ,'Australia/ACT' ,'Australia/Adelaide' ,'Australia/Brisbane' ,'Australia/Broken_Hill' ,'Australia/Canberra' ,'Australia/Currie' ,'Australia/Darwin' ,'Australia/Eucla' ,'Australia/Hobart' ,'Australia/LHI' ,'Australia/Lindeman' ,'Australia/Lord_Howe' ,'Australia/Melbourne' ,'Australia/NSW' ,'Australia/North' ,'Australia/Perth' ,'Australia/Queensland' ,'Australia/South' ,'Australia/Sydney' ,'Australia/Tasmania' ,'Australia/Victoria' ,'Australia/West' ,'Australia/Yancowinna' ,'Europe/Amsterdam' ,'Europe/Andorra' ,'Europe/Athens' ,'Europe/Belfast' ,'Europe/Belgrade' ,'Europe/Berlin' ,'Europe/Bratislava' ,'Europe/Brussels' ,'Europe/Bucharest' ,'Europe/Budapest' ,'Europe/Chisinau' ,'Europe/Copenhagen' ,'Europe/Dublin' ,'Europe/Gibraltar' ,'Europe/Guernsey' ,'Europe/Helsinki' ,'Europe/Isle_of_Man' ,'Europe/Istanbul' ,'Europe/Jersey' ,'Europe/Kaliningrad' ,'Europe/Kiev' ,'Europe/Lisbon' ,'Europe/Ljubljana' ,'Europe/London' ,'Europe/Luxembourg' ,'Europe/Madrid' ,'Europe/Malta' ,'Europe/Mariehamn' ,'Europe/Minsk' ,'Europe/Monaco' ,'Europe/Moscow' ,'Europe/Nicosia' ,'Europe/Oslo' ,'Europe/Paris' ,'Europe/Podgorica' ,'Europe/Prague' ,'Europe/Riga' ,'Europe/Rome' ,'Europe/Samara' ,'Europe/San_Marino' ,'Europe/Sarajevo' ,'Europe/Simferopol' ,'Europe/Skopje' ,'Europe/Sofia' ,'Europe/Stockholm' ,'Europe/Tallinn' ,'Europe/Tirane' ,'Europe/Tiraspol' ,'Europe/Uzhgorod' ,'Europe/Vaduz' ,'Europe/Vatican' ,'Europe/Vienna' ,'Europe/Vilnius' ,'Europe/Volgograd' ,'Europe/Warsaw' ,'Europe/Zagreb' ,'Europe/Zaporozhye' ,'Europe/Zurich' ,'Indian/Antananarivo' ,'Indian/Chagos' ,'Indian/Christmas' ,'Indian/Cocos' ,'Indian/Comoro' ,'Indian/Kerguelen' ,'Indian/Mahe' ,'Indian/Maldives' ,'Indian/Mauritius' ,'Indian/Mayotte' ,'Indian/Reunion' ,'Pacific/Apia' ,'Pacific/Auckland' ,'Pacific/Chatham' ,'Pacific/Easter' ,'Pacific/Efate' ,'Pacific/Enderbury' ,'Pacific/Fakaofo' ,'Pacific/Fiji' ,'Pacific/Funafuti' ,'Pacific/Galapagos' ,'Pacific/Gambier' ,'Pacific/Guadalcanal' ,'Pacific/Guam' ,'Pacific/Honolulu' ,'Pacific/Johnston' ,'Pacific/Kiritimati' ,'Pacific/Kosrae' ,'Pacific/Kwajalein' ,'Pacific/Majuro' ,'Pacific/Marquesas' ,'Pacific/Midway' ,'Pacific/Nauru' ,'Pacific/Niue' ,'Pacific/Norfolk' ,'Pacific/Noumea' ,'Pacific/Pago_Pago' ,'Pacific/Palau' ,'Pacific/Pitcairn' ,'Pacific/Ponape' ,'Pacific/Port_Moresby' ,'Pacific/Rarotonga' ,'Pacific/Saipan' ,'Pacific/Samoa' ,'Pacific/Tahiti' ,'Pacific/Tarawa' ,'Pacific/Tongatapu' ,'Pacific/Truk' ,'Pacific/Wake' ,'Pacific/Wallis' ,'Pacific/Yap' ,'UTC');

    public function format ($data , $params = false)
    {
        $timezones = array_flip(self::$timezonesMap);
           
        $ical = new icalCreator();
       
        $ical->setProperty( 'method' , isset($params['method']) ? $params['method'] : 'PUBLISH' );        
        $sytemTimezone = (date_default_timezone_get()) ? date_default_timezone_get() : 'America/Sao_Paulo';
        $params['defaultTZI'] = self::nomalizeTZID((isset($params['defaultTZI']) && $params['defaultTZI'] != 'null') ? $params['defaultTZI'] : $sytemTimezone  );
      
        /*
         * Seta propiedades obrigatorias para alguns softwares (Outlook)
         */
        $ical->setProperty( 'x-wr-calname', 'Calendar Expresso' );
        $ical->setProperty( 'X-WR-CALDESC', 'Calendar Expresso' );
        $ical->setProperty( 'X-WR-TIMEZONE', isset($timezones[$params['defaultTZI']]) ? $timezones[$params['defaultTZI']] : $params['defaultTZI']); 
             
        foreach($data as $i => $v)
        {
                 
            switch ($v['type']) {
                case EVENT_ID:
                    
                       $vevent = $ical->newComponent( 'vevent' );
                        
                       $vevent->setProperty( 'summary' , $v['summary'] );
                       $vevent->setProperty( 'description' , $v['description'] );
                       $vevent->setProperty( 'location' , $v['location'] );
                       $vevent->setProperty( 'tranp' , (isset($v['tranparent']) && $v['tranparent'] == TRANSP_TRANSPARENT )? 'TRANSPARENT' : 'OPAQUE' );
                      
                       $timezone = new DateTimeZone('UTC');
                       $apTimezone = self::nomalizeTZID(( isset($v['timezone']) && $v['timezone'] != 'null' ) ? $v['timezone'] : $params['defaultTZI']);
                         
                       $sTime = new DateTime( '@'.(int)($v['startTime'] / 1000) , $timezone );                                    
                       $sTime->setTimezone(new DateTimeZone($apTimezone));
                       $eTime = new DateTime( '@'.(int)($v['endTime'] / 1000) , $timezone );  
                       $eTime->setTimezone(new DateTimeZone($apTimezone));
                       
                       if( isset($v['allDay']) && $v['allDay'] == 1 )
                       {
                           $vevent->setProperty( 'dtstart' , $sTime->format(DATE_RFC822), array( "VALUE" => "DATE" ));
                           $vevent->setProperty( 'dtend' , $eTime->format(DATE_RFC822), array( "VALUE" => "DATE" ));
                           $vevent->setProperty( 'X-MICROSOFT-CDO-ALLDAYEVENT', 'TRUE' );
                       }
                       else
                       {
                           $vevent->setProperty( 'dtstart' , $sTime->format(DATE_RFC822) , array('TZID' => $apTimezone )  );
                           $vevent->setProperty( 'dtend' , $eTime->format(DATE_RFC822), array('TZID' => $apTimezone ) ); 
                           $vevent->setProperty( 'X-MICROSOFT-CDO-ALLDAYEVENT', 'FALSE' );
                       }
                       
                       if(isset($v['participants']) && is_array($v['participants']) && count($v['participants']) > 0 )
                           foreach ($v['participants'] as $pi => $pv)
                           {
                                if($pv['isOrganizer'] == 1)
                                   $vevent->setProperty( 'organizer' , $pv['user']['mail'], array( 'CN' => $pv['user']['name'] ));  
                                else
                                {
                                    $pParams = array();
                                    $pParams['CN'] = $pv['user']['name'];
                                    $pParams['PARTSTAT'] = self::_getStatus( $pv['status'] );
                                    $pParams['RSVP'] = 'TRUE';


                                    //TODO: Implementar o delegated
                                    $vevent->setProperty( 'attendee' , $pv['user']['mail'], $pParams);  
                                }

                           }

                        $vevent->setProperty( 'uid' , $v['uid'] );
                       
                       //Todo: Implementar Repetio
                                           
                    break;

                default:
                    break;
            } 
            
          
        }
                        
      return $ical->createCalendar();
    
    }
      
     public function parse ( $data , $params = false)
    {
        Config::regSet('noAlarm', TRUE); //Evita o envio de notificao
        $vcalendar = new icalCreator( ); 
        $vcalendar->parse(trim($data)); 
        $vcalendar->sort();
       
        $return = array();
        
        $method = $vcalendar->getProperty('method',FALSE , FALSE);
               
        while ($component = $vcalendar->getComponent())
        {
            
            $interation = array();
            
            switch (strtoupper($component->objName)) {
                case 'VEVENT':
                    $vevent = array();                    
                    $vevent['uid'] = $component->getProperty( 'uid' , false , false );
                    $vevent['type'] = EVENT_ID;
                    
                    $exists =  Controller::find(array('concept' => 'schedulable') , null , array ( 'deepness' => '*' , 'filter' =>  array('=' , 'uid' , $vevent['uid'] )));
                    $exists = ( is_array($exists) && count($exists) > 0 ) ? $exists[0] : false;

                    switch ($method) 
                    {
                         case 'REPLY':
                             
                               if($exists !== false)
                               {
                                   while($property = $component->getProperty('attendee',FALSE , TRUE))                                 
                                       if( $pID  = self::_getParticipantByMail(str_replace('MAILTO:', '', $property['value']), $exists['participants']))
                                            $interation['participant://'.$pID] = array( 'id' => $pID , 'status' => constant('STATUS_'.strtoupper($property['params']['PARTSTAT'])) );
                               }
                               break;

                         case 'CANCEL':
                               if($exists !== false)
                                    $interation['schedulable://'.$exists['id']] = false;
                               break;

                         default:                             
                               $veventID = mt_rand().'1(Formatter)';
                               
                               if($exists !== false)
                               {
                                  Config::regSet('noAlarm', False); //Reativa o envio de notificao
                                  $existsCalendarToSchedulable = Controller::find( array( 'concept' => 'calendarToSchedulable' ) , array('id') ,array( 'filter' => array('AND' , array('=' , 'calendar' ,  $params['calendar'] ), array('=' , 'schedulable' ,  $exists['id'] ) )) ); 
                                            
                                    
                                  if( !is_array($existsCalendarToSchedulable) || count($existsCalendarToSchedulable) < 1 )
                                  {  
                                      $calendarToSchedulable = array();
                                      $calendarToSchedulable['calendar'] = $params['calendar'];
                                      $calendarToSchedulable['schedulable'] = $exists['id'];
                                      $interation['calendarToSchedulable://'.mt_rand().'(Formatter)'] = $calendarToSchedulable;
                                      continue;
                                  }
// Codigo para atualizar status do importador. no nescessario pois sera enviado um email de configmao para o organizador.
//                         foreach ($exists['participants'] as  $participant)
//                           if($participant['user']['id'] == Config::me('uidNumber'))
//                               $interation['participant://'.$participant['id']] = array( 'id' => $participant['id'], 'status' => STATUS_CONFIRMED);
                                    
                                 $veventID = $exists['id'];
                                 $vevent = $exists;
                               }
                          
                                /* Data de Inicio*/
                                    $startTime = $component->getProperty( 'dtstart', false , true );

                                /* Tiem zone do evento*/    
                                   if(isset($startTime['params']['TZID']))
                                      $vevent['timezone'] = self::nomalizeTZID ($startTime['params']['TZID']); 
                                   else
                                      $vevent['timezone'] = $params['calendar_timezone'] ? $params['calendar_timezone'] : 'America/Sao_Paulo'; 

                                    if($startTime['params']['VALUE'] === 'DATE' && isset($params['calendar_timezone']) )
                                    {
                                        $vevent['allDay'] = 1;
                                        $vevent['startTime'] = self::date2timestamp($startTime['value']) - self::_getTzOffset('UTC',$params['calendar_timezone']) . '000';
                                    }
                                    elseif(isset($startTime['params']['TZID']) && !isset($startTime['value']['tz']))/* Caso no tenha um tz na data mais exista um parametro TZID deve ser aplicado o timezone do TZID a data */
                                        $vevent['startTime'] = self::date2timestamp($startTime['value']) - self::_getTzOffset('UTC',$startTime['params']['TZID']) . '000';      
                                    else
                                        $vevent['startTime'] = self::date2timestamp($startTime['value']) . '000';                         

                                 /* Data de Termino*/
                                    $endTime = $component->getProperty( 'dtend', false , true ); 

                                    if($endTime['params']['VALUE'] === 'DATE')
                                        $vevent['endTime'] = self::date2timestamp($endTime['value']) - self::_getTzOffset('UTC',$params['calendar_timezone']) . '000';
                                    else if(isset($endTime['params']['TZID']) && !isset($endTime['value']['tz'])) /* Caso no tenha um tz na data mais exista um parametro TZID deve ser aplicado o timezone do TZID a data */
                                        $vevent['endTime'] = self::date2timestamp($endTime['value']) - self::_getTzOffset('UTC',$endTime['params']['TZID']) . '000';
                                    else
                                        $vevent['endTime'] = self::date2timestamp($endTime['value']) . '000';

                                $vevent['summary'] = mb_convert_encoding ( $component->getProperty( 'summary' , false , false ) , 'UTF-8' , 'UTF-8,ISO-8859-1');

                                /* Definindo Description */
                                    if($desc = $component->getProperty( 'description' , false , false ))
                                        $vevent['description'] = mb_convert_encoding (str_ireplace ('\n', "\n", $desc) ,'UTF-8' , 'UTF-8,ISO-8859-1');

                                 /* Definindo location */
                                    if($location = $component->getProperty( 'location' , false , false ))
                                        $vevent['location'] = mb_convert_encoding ( $location , 'UTF-8' , 'UTF-8,ISO-8859-1') ;


                                /* Definindo Class */
                                    $class = $component->getProperty( 'class' , false , false );
                                    if( $class && defined(constant(strtoupper('CLASS_'.$class))) )
                                        $vevent['class'] = constant(strtoupper('CLASS_'.$class));
                                    else if( !isset($exists['class']) )
                                        $vevent['class'] = CLASS_PRIVATE ; // padro classe private

                                /* Definindo RRULE */
                                    if(  $rrule = $component->getProperty( 'rrule' , false , false ))
                                    {   
                                        /* Gera um randon id para o contexto formater */
                                            $repeatID = mt_rand().'3(Formatter)';

                                        $repeat = array();
                                        $repeat['schedulable'] = $veventID;
                                        foreach($rrule as $i => $v)
                                           $repeat[strtolower($i)] = $v;

                                        $interation['repeat://'.$repeatID] = $repeat;
                                    }


                                $vevent['calendar'] = $params['calendar'];           

                                $participantsInEvent = array();

                                //TODO: Participants com delegated no estao sendo levados em conta
                                while($property = $component->getProperty('attendee',FALSE , TRUE))
                                {
                                    $participant = array();

                                    $mailUser = trim(str_replace('MAILTO:', '', $property['value']));

                                    $participantID = mt_rand().'2(Formatter)';
                                    $participant['schedulable'] = $veventID;                                      
                                    $participant['status'] = (isset($property['params']['PARTSTAT']) && constant('STATUS_'.$property['params']['PARTSTAT']) !== null ) ? constant('STATUS_'.$property['params']['PARTSTAT']) : STATUS_UNANSWERED;
                                    $participant['isOrganizer'] = '0';

                                    /* Verifica se este usuario  um usuario interno do ldap */     
                                    $intUser = Controller::find( array( 'concept' => 'user', 'service' => 'OpenLDAP' ) , array('uidNumber') ,array( 'filter' => array('OR' , array('=' , 'mail' ,  $mailUser ), array('=' , 'mailAlternateAddress' ,  $mailUser ) )) ); 

                                    if( !is_array($intUser) || count($intUser) < 1 )
                                         $intUser = Controller::find( array( 'concept' => 'user' ,'service' => 'PostgreSQL') , array('uidNumber') ,array( 'filter' => array('=' , 'mail' ,  $mailUser )) ); 


                                    $user = null;    
                                    if( $intUser && count($intUser) > 0 )
                                    {
                                        $participant['isExternal']  = 0;
                                        $participant['user'] = $intUser[0]['id'];
                                    }
                                    else
                                    {
                                        $participant['isExternal']  = 1;
                                         /* Gera um randon id para o contexto formater */
                                            $userID = mt_rand().'4(Formatter)';

                                        $user['mail'] = $mailUser;
                                        $user['isExternal'] = '1';
                                        $user['name'] =  ( isset($property['params']['CN']) ) ? $property['params']['CN'] : '';
                                        $user['participants'] = array($participantID);
                                        $participant['user'] = $userID;
                                        $interation['user://'.$userID] = $user;
                                    }

                                    $interation['participant://'.$participantID] = $participant;
                                    $vevent['participants'][] = $participantID;

                                };

                                if($property = $component->getProperty('organizer',FALSE , TRUE))
                                {
                                    $participant = array();
                                    $mailUser = trim(str_replace('MAILTO:', '', $property['value']));

                                    $participantID = mt_rand().'2(Formatter)';

                                    $participant['schedulable'] = $veventID;
                                    $participant['status'] = (isset($property['params']['PARTSTAT']) && constant('STATUS_'.$property['params']['PARTSTAT']) !== null ) ? constant('STATUS_'.$property['params']['PARTSTAT']) : STATUS_UNANSWERED;
                                    $participant['isOrganizer'] = '1';

                                    /* Verifica se este usuario  um usuario interno do ldap */     
                                    $intUser = Controller::find( array( 'concept' => 'user' ,'service' => 'OpenLDAP') , array('uidNumber') ,array( 'filter' => array('OR' , array('=' , 'mail' ,  $mailUser ), array('=' , 'mailAlternateAddress' ,  $mailUser ) )) ); 

                                    if( !is_array($intUser) || count($intUser) < 1 )
                                         $intUser = Controller::find( array( 'concept' => 'user' ,'service' => 'PostgreSQL') , array('uidNumber') ,array( 'filter' => array('=' , 'mail' ,  $mailUser )) ); 



                                    $user = null;    
                                    if( $intUser && count($intUser) > 0 )
                                    {
                                        $participant['isExternal']  = 0;
                                        $participant['user'] = $intUser[0]['id'];
                                    }
                                    else
                                    {
                                        $participant['isExternal']  = 1;
                                         /* Gera um randon id para o contexto formater */
                                            $userID = mt_rand().'4(Formatter)';

                                        $user['mail'] = $mailUser;
                                        $user['name'] =  ( isset($property['params']['CN']) ) ? $property['params']['CN'] : '';
                                        $user['participants'] = array($participantID);
                                        $user['isExternal'] = '1';
                                        $participant['user'] = $userID;
                                        $interation['user://'.$userID] = $user;
                                    }

                                    $interation['participant://'.$participantID] = $participant;
                                    $vevent['participants'][] = $participantID;

                                }
                                else //caso no tenha organizador o usuario se torna organizador
                                {
                                   $user = Controller::read( array( 'concept' => 'user', 'id' => $params['owner'] ) , array('mail')); 

                                   if(!self::_getParticipantByMail($user['mail'] , $exists['participants']))
                                   {
                                        $participantID = mt_rand().'2(Formatter)';

                                        $participant['schedulable'] = $veventID;
                                        $participant['status'] = STATUS_CONFIRMED;
                                        $participant['isOrganizer'] = '1';
                                        $participant['isExternal']  = 0;
                                        $participant['user'] =  $params['owner'];
                                        $interation['participant://'.$participantID] = $participant;
                                        $vevent['participants'][] = $participantID;
                                   }
                                }

                                 /* Definindo DTSTAMP */
                                if($dtstamp = $component->getProperty( 'dtstamp', false , true ))
                                {
                                    if(isset($dtstamp['params']['TZID']) && !isset($dtstamp['value']['tz']))
                                        $vevent['dtstamp'] = self::date2timestamp($dtstamp['value']) - self::_getTzOffset('UTC',$dtstamp['params']['TZID']) . '000';
                                    else
                                        $vevent['dtstamp'] = self::date2timestamp($dtstamp['value']) . '000';
                                }

                                /* Definindo TRANSP */
                                if(($tranp = $component->getProperty( 'transp', false , true )) && strtoupper($tranp) == 'OPAQUE')
                                    $vevent['transparent'] = 1;

                                 /* Definindo last_update */
                                if($lastUpdate = $component->getProperty( 'LAST-MODIFIED', false , true ))
                                {
                                    if(isset($lastUpdate['params']['TZID']) && !isset($lastUpdate['value']['tz']))
                                        $vevent['lasUpdate'] = self::date2timestamp($lastUpdate['value']) - self::_getTzOffset('UTC',$lastUpdate['params']['TZID']) . '000';
                                    else
                                        $vevent['lastUpdate'] = self::date2timestamp($lastUpdate['value']) . '000';
                                }

                                $interation['schedulable://'.$veventID] = $vevent;

                               break;
                             
                    }
                    
                    $return[] = $interation;
                    break;
               case 'VTIMEZONE':


                    break;
            }
        
        }
        
         return $return;   
    }
    
    /* Helpers */
        private static function _getTzOffset($rTz, $oTz = null) 
        {
            if($oTz === null) {
                if(!is_string($oTz = date_default_timezone_get())) {
                    return false; // A UTC timestamp was returned -- bail out!
                } 
            }
            $origin_dtz = new DateTimeZone(self::nomalizeTZID($oTz));
            $remote_dtz = new DateTimeZone(self::nomalizeTZID($rTz));
            $origin_dt = new DateTime("now", $origin_dtz);
            $remote_dt = new DateTime("now", $remote_dtz);
            $offset = $origin_dtz->getOffset($origin_dt) - $remote_dtz->getOffset($remote_dt);
            return $offset;
        }

        private function _getStatus( $id )
        {
            $a = array(    
                        STATUS_CONFIRMED =>  'CONFIRMED',
                        STATUS_CANCELLED =>  'CANCELLED',
                        STATUS_TENATIVE =>   'TENATIVE',
                        STATUS_UNANSWERED => 'NEEDS-ACTION',
                        STATUS_DELEGATED =>  'DELEGATED'
		      );
            
             return isset($a[ $id ]) ? $a[ $id ] : 'NEEDS-ACTION';
        }
        
        private static function _getParticipantByMail( $mail , &$participants )
        {
                    
            foreach ($participants as $i => $v)
                if($v['user']['mail'] == $mail  || (isset($v['user']['mailAlternateAddress']) && in_array($mail, $v['user']['mailAlternateAddress'])))
                    return $v['id'];                        
                
            return false;
        }
        
        static private function nomalizeTZID ($TZID)
        { 
            if(isset(self::$timezonesMap[$TZID]))
                return self::$timezonesMap[$TZID];
            else if(in_array($TZID, self::$suportedTimzones))
                return $TZID;
            else 
                return date_default_timezone_get();       
        }   
        
        static private function date2timestamp( $datetime, $tz=null ) 
        {
            if( !isset( $datetime['hour'] )) $datetime['hour'] = '0';
            if( !isset( $datetime['min'] ))  $datetime['min']  = '0';
            if( !isset( $datetime['sec'] ))  $datetime['sec']  = '0';
         
            foreach( $datetime as $dkey => $dvalue ) 
              if( 'tz' != $dkey )
                $datetime[$dkey] = (integer) $dvalue;
            
            if( $tz )
              $datetime['tz'] = $tz;
            
            $offset = ( isset( $datetime['tz'] ) && ( '' < trim ( $datetime['tz'] ))) ? iCalUtilityFunctions::_tz2offset( $datetime['tz'] ) : 0;
            
            return gmmktime( $datetime['hour'], $datetime['min'], ($datetime['sec'] + $offset), $datetime['month'], $datetime['day'], $datetime['year'] );   
        }

}
?>
